<?php

// helper classes do not need constants / defines

class Sessions {
    const EXPIRED_TOKEN = "Expired";
    
    public function __construct($conn = NULL, $Log = NULL) {
        $this->conn = $conn;
        $this->Log = $Log;
    }
    
    public function newSession($userId, $time){
        $token = false;

        $expires = $time + (60 * 60 * 7 * 24); // 1 week out
        $uuid = $this->createGUID();

        $str = "INSERT INTO mgportal.sessions (userid, uuid, expiry)";
        $str .= " VALUES (%d, '%s', %d);";
        $query = sprintf($str, $userId, $uuid, $expires);

        $result = pg_query($this->conn, $query);
        if ($result !== false){
            //$row = pg_fetch_row($result);
            //$session_id = $row[0];
            $cookie = $userId . ":" . $uuid . ":" . $expires;
            $token = base64_encode($cookie);
        } else {
            $this->Log->logError("Error saving session");
        }
        return $token;
    }

    private function createGUID(){
        if (function_exists('com_create_guid') === true){
            return trim(com_create_guid(), '{}');
        }
        return sprintf('%04X%04X-%04X-%04X-%04X-%04X%04X%04X',
               mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535),
               mt_rand(16384, 20479), mt_rand(32768, 49151),
               mt_rand(0, 65535), mt_rand(0, 65535), mt_rand(0, 65535));

    }
    
    public function doesUserSessionExist($userid){
        $query = "SELECT userid, uuid, expiry FROM mgportal.sessions";
        $query .= " WHERE userid=" . $userid . ";";


        $db = new Database();
        $conn = $db->connect();
        $dbSessions = pg_query($conn, $query);
        $db->closeConnection();
        if ($dbSessions !== false){
            return true;
        }
        return false;
    }

    public function isTokenValid($inToken){
        
        $valid = false;     // initialize as an invalid token.
        
        // deconstruct token first
        $token = base64_decode($inToken);
        $token = explode(":",$token);
        $inUser = $token[0];
        $inGUID = $token[1];
        $inExpiry = $token[2];

        $query = "SELECT userid, uuid, expiry FROM mgportal.sessions";
        $query .= " WHERE userid=" . $inUser . " AND uuid='" . $inGUID;
        $query .= "' AND expiry=" . $inExpiry . ";";


        $db = new Database();
        $conn = $db->connect();
        if ($conn !== false) {
            $dbSessions = @pg_query($conn, $query);
            if ($dbSessions !== false){
                $row = pg_fetch_row($dbSessions);
                if ($row !== ""){
                    $expires = $row[2];
                    $db->closeConnection();
                    if (time() < $expires){
                        $valid = true;
                    } else {
                        $valid = Sessions::EXPIRED_TOKEN;
                    }
                }
            }
            $db->closeConnection();
        }
        return $valid;
    }

    public function deleteSession($inToken){
        $token = base64_decode($inToken);
        $token = explode(":",$token);
        $inUser = $token[0];
        $inGUID = $token[1];
        $inExpiry = $token[2];

        $query = "DELETE FROM mgportal.sessions WHERE userid=";
        $query .= $inUser;
        $query .= " AND uuid='";
        $query .= $inGUID . "';";

        $result = false;
        $db = new Database();
        $conn = $db->connect();
        if ($conn !== false) {
            $result = pg_query($conn, $query);
            if ($result !== false){
                $row = pg_fetch_row($result);
                if ($row === null){
                    $result = array(
                        'result' => false,
                        'message' => "Error: could not find session in session table"
                    );
                } else {
                    $result = true;
                }
            } else {
                $message = "Error deleting session for " . $inUser;
                $this->Log->logError($message);
                $result = array(
                    'result' => false,
                    'message' => $message
                );
            }
            $db->closeConnection();
        }
        return $result;
    }

    public function deleteUserSessions($inUser){
        $query = "DELETE FROM mgportal.sessions WHERE userid=";
        $query .= $inUser;
        $query .= ";";

        $result = false;
        $result = pg_query($this->conn, $query);
        if ($result !== false){
            $row = pg_fetch_row($result);
            if ($row === null){
                $result = array(
                    'result' => false,
                    'message' => "Error: could not find session for the provided userid"
                );
            } else {
                $result = true;
            }
        } else {
            $message = "Error deleting session for " . $inUser;
            $this->Log->logError($message);
            $result = array(
                'result' => false,
                'message' => $message
            );
        }
        return $result;
    }
};

?>
